<?php
/*
<?php //exemplo funcionou com o ACBrMonitor
$fp = fsockopen("127.0.0.1", 3434, $errno, $errstr);
if (!$fp) {
    echo "ERROR: $errno - $errstr<br />\n";
} else {
    fwrite($fp, "\n");
    echo fread($fp, 26);
    fwrite($fp, "ECF.Ativar \n");
    echo fread($fp, 26);
    fwrite($fp, "ECF.DataHora \n");//ECF.DataHora;ECF.NumCupom;ECF.NumSerie
    echo fread($fp, 26);
    fwrite($fp, "ECF.NumCupom \n");
    echo fread($fp, 26);
    fwrite($fp, "ECF.NumSerie \n");
    echo fread($fp, 26);
    fclose($fp);
}
?>
*/
/*Classe destinada a comunicao tcp/ip com o ACBrMonitor
Baseado no exemplo do manual do php
adaptada por Helder Mauricio Gomes Ferreira
observe a chamada por referencia de &$r
*/
class B2StokTelnet {
	var $show_connect_error=1;

	var $use_usleep=0;	//Troque para 1 e a execuao ser mais rapida 
		//No utilize 1 com rWindows servers se voce utiliza uma vero menor que PHP 5
	var $sleeptime=125000;//microsegundos 1/8 de segundo
	var $loginsleeptime=1000000; //no utilizei equivale a 1 segundo

	var $fp=NULL;
		
	
	//retorno da funo abaixo
	/*
	0 = success
	1 = couldn't open network connection
	2 = unknown host
	3 = login failed
	4 = PHP version too low
	*/
	function Connect($server,$porta,$user,$pass,&$r) {
		$rv=0;//variavel de erro
        //verificando a vero do php no mepergunte porque
		$vers=explode('.',PHP_VERSION);
		$needvers=array(4,3,0);
		$j=count($vers);
		$k=count($needvers);
		if ($k<$j) $j=$k;
		for ($i=0;$i<$j;$i++) {
			if (($vers[$i]+0)>$needvers[$i]) break;
			if (($vers[$i]+0)<$needvers[$i]) {
				$this->ConnectError(4);
				return 4;
			}
		}
		
		$this->Disconnect();
		
		if (strlen($server)) {
            //verifica se  um ip valido
			if (preg_match('/[^0-9.]/',$server)) {//Searches subject  for a match to the regular expression given in pattern .
                //busca em um dns o IP 
				$ip=gethostbyname($server);//Returns the IP address of the Internet host specified by hostname . 
				if ($ip==$server) {
					$ip='';
					$rv=2;//gera um erro 2
                }
			} else {$ip=$server;}
		} else {$ip='127.0.0.1';}
		
		if (strlen($ip)) {
			if ($this->fp=fsockopen($ip,$porta)) {//conectou ok
                
				$this->Sleep();   //da um tempo
				
				//busca resposta do servidor
				$this->GetResponse($r);
				$t=explode("\n",$r);//quebra a respostas em linhas
                print_r($t);//imprime no console para monitorar
				//verifica se esta vazio
                //aqui devo procurar a existencia da resposta conforme abaixo
                /*
                [0] => ACBrMonitor Ver. 0.8.4b - ACBr: 0.8.7b
                [1] => Conectado em: 09-01-09 14:31:18
                [2] => M?quina: 127.0.1.1
                [3] => Esperando por comandos.*/
                $j=explode(" ",$t[0]);
                //echo "{$j[0]}\n";
                if (($j[0]!='ACBrMonitor')) {
					$rv=3;
					$this->Disconnect();
				}
                }else $rv=1;
		}
		
		if ($rv) $this->ConnectError($rv);
		return $rv;
	}
	
	function Disconnect($exit=1) {
		if ($this->fp) {
			if ($exit) $this->DoCommand('exit',$junk);//Bye, Exit, Sair ou Fim qualquer deste comando encerra o ACBrMonitor
			fclose($this->fp);
			$this->fp=NULL;
            $r="OK: Coneco foi desconectada";
		}else{
                $r="ERRO: Queda na coneco com o ACBrMonitor";
                }
	}
    function EnviaCommand($c,&$r) {//envia uma string para o servidor de telnet mas no le a resposta
        
		if ($this->fp) {//verifica se ponteiro  verdadeiro
			fwrite($this->fp,"$c \n");//escreve o contedo da string  para o stream de arquivo apontado por handle . 
            }else{
                $r="ERRO: Queda na coneco com o ACBrMonitor";
                }
		return $this->fp?1:0;//retorna se o ponteiro  verdadeiro ou falso
	}
	function DoCommand($c,&$r) {//envia uma string para o servidor de telnet
        
		if ($this->fp) {
			fputs($this->fp,"$c \n");//aqui tem que ter espao e \n no pode ser \r//mesmo que fwrite() escreve o contedo da string  para o stream de arquivo apontado por handle . 
			$this->Sleep();// dorme um pouco esperando estabilidade na resposta
			$this->GetResponse($r); //busca a resposta
			$r=preg_replace("/^.*?\n(.*)\n[^\n]*$/","$1",$r);//limpa a variavel $r
            
		}else{
            $r="ERRO: Queda na coneco com o ACBrMonitor";
        }
		return $this->fp?1:0;//caso haja erro aqui retorna 0
	}
	
	function GetResponse(&$r) {//busca a resposta
		$r='';//limpa o buffer
        do {$t=fread($this->fp,1000);
            //Este caracter   a finalizao da resposta do acbrmonitor equivale a asc(3) ou #3;
            $t=str_replace('','',$t);//retira este caracter da resposta
            $t=str_replace("\r\n","", $t);//retira a quebra de linha e linefeed da resposta LFCR
            $r.=$t;
			$s=socket_get_status($this->fp);//verifica se ainda tem linhas ou dados Sinnimo de stream_get_meta_data()
            } while ($s['unread_bytes']); //testa se  verdadeiro ou falso
	}
	
	function Sleep() {//dormir um pouco
		if ($this->use_usleep){
        
         usleep($this->sleeptime);//dorme em milisegundos
        echo "colocando para dormir $this->use_usleep";
        }
		else sleep(1);//dorme 1segundo
	}


	
	
	
	function ConnectError($num) {//so utilize se voce esta rodando do php-gtk2
		if ($this->show_connect_error) switch ($num) {
        case 0: break;//conectou correto
		case 1: obs('<b>[B2Stok to ACBrMonitor] Coneco Falhou:</b> Erro ao abrir coneo com o ACBrMonitor veja se voce escolheu conees ou se ele esta rodando'); break;
		case 2: obs('<b>[B2Stok to ACBrMonitor] Coneco Falhou:</b> Unknown host'); break;
		case 3: obs('<b>[B2Stok to ACBrMonitor] Coneco Falhou:</b> Voce no conectou com o ACBrMoitor'); break;
		case 4: obs('<b>[B2Stok to ACBrMonitor] Coneco Falhou:</b> Voce no esta rodando Php-Gtk2 com PHP5'); break;
		}
	}
}
?>