<?
/**
 * DANFE
 * dfadel
 * 22/07/2009
 *
 * Multiplas pginas, organizao rodap, cabealho
 * dlemes
 * Classe PDF_Code128 obtida em: http://www.fpdf.org/en/script/script88.php
 *
 * TODO: expandir para mltiplas folhas
 */

include_once(dirname(__FILE__).'/fpdf/fpdf.php');
include_once(dirname(__FILE__).'/fpdf/code128.php');

if (!defined('FPDF_FONTPATH')) {
	$path=$_ENV["PWD"].bar.'libs'.bar.'fpdf'.bar.'font'.bar;
	//echo "\nvisuaNFe.class.php linha 19 ****************\n  Definindo o path para as fontes do pdf $path \n";
	define('FPDF_FONTPATH',$path);
}

if (!function_exists('dmy2ymd')) {
    function dmy2ymd($data) {
        if (!empty($data)) {
            $needle = "/";
            if (strstr($data, "-")) {
                $needle = "-";
            }
            $dt = explode($needle, $data);
            return "$dt[2]-$dt[1]-$dt[0]";
        }
    }
}

class visuaNFe extends PDF_Code128{

    public $canhoto;   // se true, imprime campos do canhoto
    public $issqn;     // se true, imprime campos do issqn
    public $pdf;       // objeto fpdf()
    public $xml;       // string XML NFe
    public $logo;      // path para logomarca
    public $array_uf;  // usado para obter c�digo do estado do destinatario qdo em contingencia
    public $protocolo; // protocolo de autorizacao deve sair em infCpl
    public $data_hora; // data e hora de autorizacao devem sair em infCpl
	private $infNFe;
	private $ide;
	private $emit;
	private $dest;
	private $enderEmit;
	private $enderDest;
	private $det;
	private $cobr;
	private $dup;
	private $ICMSTot;
	private $transp;
	private $transporta;
	private $veicTransp;
	private $vols;
	private $infAdic;
	private $issqn_extra;
    private $signature;

   private $gi=0;
   private $linha=array();
   private $vbox=array();
   private $ntbk;
   private $cellGtk=array();
    function __construct($xml, $formato="P") {
		parent::__construct($formato, 'mm', 'A4');
		
		$dom = new DomDocument;
        $dom->loadXML($xml);
		$this->infNFe     = $dom->getElementsByTagName("infNFe")->item(0);
        $this->ide        = $dom->getElementsByTagName("ide")->item(0);
        $this->emit       = $dom->getElementsByTagName("emit")->item(0);
        $this->dest       = $dom->getElementsByTagName("dest")->item(0);
        $this->enderEmit  = $dom->getElementsByTagName("enderEmit")->item(0);
        $this->enderDest  = $dom->getElementsByTagName("enderDest")->item(0);
        $this->det        = $dom->getElementsByTagName("det");
        $this->cobr       = $dom->getElementsByTagName("cobr")->item(0);
        $this->dup        = $dom->getElementsByTagName('dup');
        $this->ICMSTot    = $dom->getElementsByTagName("ICMSTot")->item(0);
        $this->transp     = $dom->getElementsByTagName("transp")->item(0);
        $this->transporta = $dom->getElementsByTagName("transporta")->item(0);
        $this->veicTransp = $dom->getElementsByTagName("veicTransp")->item(0);
        $this->vols       = $dom->getElementsByTagName("vol");
        $this->infAdic    = $dom->getElementsByTagName("infAdic")->item(0);
        $this->signature  = $dom->getElementsByTagName("Signature")->item(0);
		$this->canhoto   = true;
        $this->issqn     = false;
		//$this->PDF_Code128($formato, 'mm', 'A4'); 
		$this->AddPage();
		$this->xml       = $xml;
        $this->logomarca = 'logomarca.jpg';
        $this->array_uf  = array('SP' => 35);
    }


    function mask_cnpj($c) {
        return sprintf("%s.%s.%s/%s-%s", $c[0].$c[1], $c[2].$c[3].$c[4], $c[5].$c[6].$c[7], $c[8].$c[9].$c[10].$c[11], $c[12].$c[13]);
    }


    function mask_cpf($c) {
        return sprintf("%s.%s.%s-%s", $c[0].$c[1].$c[2], $c[3].$c[4].$c[5], $c[6].$c[7].$c[8], $c[9].$c[10]);
    }


    function mask_nnf($n) {
        $n = sprintf("%09s", $n);
        return sprintf("%s.%s.%s", $n[0].$n[1].$n[2], $n[3].$n[4].$n[5], $n[6].$n[7].$n[8]);
    }

    function mask_chave($c) {
        for ($i=0; $i<=strlen($c); ++$i) {
            $cf.= $c[$i-1];
            if ($i % 4 == 0) {
                $cf.= " ";
            }
        }
        return $cf;
    }


    function calcula_dv($chave35) {
        $multiplicadores = array(2,3,4,5,6,7,8,9);
        $i = 34;
        while ($i >= 0) {
            for ($m=0; $m<count($multiplicadores) && $i>=0; $m++) {
                $soma_ponderada+= $chave35[$i] * $multiplicadores[$m];
                $i--;
            }
        }
        $resto = $soma_ponderada % 11;
        if ($resto == '0' || $resto == '1') {
            $dv = 0;
        } else {
            $dv = 11 - $resto;
        }
        return $dv;
    }

    function linhagtk($label)
    { 
    $this->gi ++;
    $this->linha[$this->gi] = new Linha($label);
    
    }
    function cellgtk($altura, $largura, $esquerda, $superior, $sbordas, $label="", $fonte="", $texto="", $tfonte="") 
    {	
      $this->linha[$this->gi]->setcell($label,$texto);
    }
   
    /**
     * Gera Linha superior
     * @param	string   $xml
     * @param   string   $formato P=portrait L=landscape
     * @return
     * @access  public
     * @author Helder M G Ferreira
     *
     **/
	function Superior(){
	//cria uma linha linhagtk
    	$this->linhagtk("Consulta da NF-e");//linha fixa aparece sempre
	//cria a celula Chave de Acesso
	$this->cellgtk( 9.6,    80, 120.0,  40.2,  "BTRL",  "CHAVE DE ACESSO", "", $this->mask_chave($chave_acesso), "Courier,B,6.5,L");
	//cria a celula Numero NF-e
	$this->cellgtk(8.5, 20, 168,  6.7, "", "Nmero NF-e", "", $this->mask_nnf($this->ide->getElementsByTagName('nNF')->item(0)->nodeValue),   "Courier,B,9,L");
	//cria a celula Verso XML
	$this->cellgtk(9.6,    80, 120.0,  40.2,  "BTRL",  "Verso XML", "", "1.10", "Courier,B,6.5,L");
	return $this->linha[$this->gi]->getlinha();//retorna um objeto $hbox com todas as celulas
        }
        //pagina um do notebook
        Function pag1()
        {
        $this->linhagtk("Dados da NF-e");
        //Nmero
        $this->cellgtk('','','','','',"Numero", "", $this->mask_nnf($this->ide->getElementsByTagName('nNF')->item(0)->nodeValue), "");
        //Srie
        $this->cellgtk('','','','','',"Srie", "",        $this->ide->getElementsByTagName('serie')->item(0)->nodeValue, "");
        //Data de emisso
        $data_emissao = dmy2ymd($this->ide->getElementsByTagName("dEmi")->item(0)->nodeValue);
        $this->cellgtk('','','','','',"Data de emisso", "",        $data_emissao, "");
        //Valor Total da Nota Fiscal
        $valortotalnota=number_format($this->ICMSTot->getElementsByTagName("vNF")->item(0)->nodeValue, 2, ",", ".");
        $this->cellgtk('','','','','',"Valor Total da Nota Fiscal", "",$valortotalnota, "");
//dados da linha pronto
$linha[0]=$this->linha[$this->gi]->getlinha();
        // linha emitente EMITENTE
         $this->linhagtk("EMITENTE");
 	//CNPJ
 	$this->cellgtk('','','','','',"C.N.P.J.", "", $this->mask_cnpj($this->emit->getElementsByTagName("CNPJ")->item(0)->nodeValue), "");
 	//Nome / Razo Social 
 	$this->cellgtk('','','','','',"Nome / Razo Social", "", utf8_decode($this->emit->getElementsByTagName("xNome")->item(0)->nodeValue), "");
 	//Inscrio Estadual 
 	$this->cellgtk('','','','','',"INSCRIO ESTADUAL", "", utf8_decode($this->emit->getElementsByTagName("IE")->item(0)->nodeValue), "");
 	//UF 
 	$this->cellgtk('','','','','',"UF", "", $this->enderEmit->getElementsByTagName("UF")->item(0)->nodeValue, "");
//dados da linha pronto
$linha[1]=$this->linha[$this->gi]->getlinha();
        //DESTINATRIO
  	$this->linhagtk("DESTINATRIO");
 	//CNPJ
 	$this->cellgtk('','','','','',"C.N.P.J.", "", $this->mask_cnpj($this->dest->getElementsByTagName("CNPJ")->item(0)->nodeValue), "");
 	//Nome / Razoo Social 
 	$this->cellgtk('','','','','',"Nome / Razo Social", "", utf8_decode($this->dest->getElementsByTagName("xNome")->item(0)->nodeValue), "");
 	//Inscrio Estadual 
 	$this->cellgtk('','','','','',"INSCRIO ESTADUAL", "", utf8_decode($this->dest->getElementsByTagName("IE")->item(0)->nodeValue), "");
 	//UF 
 	$this->cellgtk('','','','','',"UF", "", utf8_decode($this->enderDest->getElementsByTagName("UF")->item(0)->nodeValue), "");
//dados da linha pronto
$linha[2]=$this->linha[$this->gi]->getlinha();
        //EMISSO
        $this->linhagtk("EMISSO");
  	//Processo
  	$processo=$this->ide->getElementsByTagName("procEmi")->item(0)->nodeValue;
  	switch ($processo) {
	case 0:
		$txtproc= "0 - emisso de NF-e com aplicativo do contribuinte";
		break ;
	case 1:
		$txtproc= "1 - emisso de NF-e avulsa pelo Fisco";
		break ;
	case 2:
		$txtproc= "2 - emisso de NF-e avulsa, pelo contribuinte com seu certificado digital,
	através do site do Fisco";
		break ;
	case 3:
		$txtproc= "3- emisso NF-e pelo contribuinte com aplicativo fornecido pelo Fisco";
		break ;
	}

  	$this->cellgtk( '', '',  '',  '',  "",  "Processo", "", $txtproc,'');
  	//Verso do Processo
  	$this->cellgtk( '', '',  '',  '',  "",  "Verso do Processo", "", utf8_decode($this->ide->getElementsByTagName("verProc")->item(0)->nodeValue),'');
  	//Forma  tpEmis   1-Normal/ 2-Contingncia
  	$tpEmis=utf8_decode($this->ide->getElementsByTagName("tpEmis")->item(0)->nodeValue);
  	switch ($tpEmis) {
    
	case 1:
		$txttpEmis= "1-Normal";
		break ;
	case 2:
		$txttpEmis= "2-Contingncia";
		break ;
		}
  	$this->cellgtk( '', '',  '',  '',  "",  "Forma", "", $txttpEmis,'');
  	//Finalidade  /  / 
  	$finNFe=utf8_decode($this->ide->getElementsByTagName("finNFe")->item(0)->nodeValue);
  	switch ($finNFe) {
    
	case 1:
		$txtfim= "1-NF-e normal";
		break ;
	case 2:
		$txtfim= "2-NF-e complementar";
		break ;
	case 3:
		$txtfim= "3-NF-e de ajuste";
		break ;
	}
  	$this->cellgtk( '', '',  '',  '',  "",  "Finalidade", "", $txtfim,'');
  	
//dados da linha pronto
$linha[3]=$this->linha[$this->gi]->getlinha();
	//Natureza da Operao
$this->linhagtk("");
	$this->cellgtk( '', '',  '',  '',  "",  "Natureza da Operao", "", utf8_decode($this->ide->getElementsByTagName("natOp")->item(0)->nodeValue),'');
	//Tipo da Operao tpNF 0-entrada / 1-saída
	$tpNF=utf8_decode($this->ide->getElementsByTagName("tpEmis")->item(0)->nodeValue);
  	switch ($tpNF) {
    
	case 0:
		$txttpNF= "0-entrada";
		break ;
	case 1:
		$txttpNF= "1-sada";
		break ;
		}
  	$this->cellgtk( '', '',  '',  '',  "",  "Forma", "", $txttpNF,'');
	//Digest Value da NF-e  
	//@TODO precisa encontrar uma maneira de retornar <DigestValue>
	$this->cellgtk( '', '',  '',  '',  "",  "Digest Value da NF-e", "", $this->signature->getElementsByTagName("DigestValue")->item(0)->nodeValue,'');
  	//dados da linha pronto
$linha[4]=$this->linha[$this->gi]->getlinha();
return $linha; //deveria ser por referencia
        }
     /**
     * Gera Pagina 3 Dados do Destinatrio 
     * @param	string   $xml
     * @param   string   $formato P=portrait L=landscape
     * @return
     * @access  public
     * @author Daniel B. Lemes
     *
     **/

    //pagina um do notebook
        Function pag3()
        {
        $this->linhagtk("Dados do Destinatrio");
        //Nome / Razo Social 
        $this->cellgtk('','','','','',"Nome / Razo Social", "", utf8_decode($this->dest->getElementsByTagName("xNome")->item(0)->nodeValue), "");
        //Nome fantasia
       // $this->cellgtk('','','','','',"Nome Fantasia", "", utf8_decode($this->dest->getElementsByTagName("xFant")->item(0)->nodeValue), "");
        //dados da linha pronto
        $linha[0]=$this->linha[$this->gi]->getlinha();
        // linha emitente CNPJ ENDEREO
         $this->linhagtk("");
        //CNPJ
 	    $this->cellgtk('','','','','',"C.N.P.J.", "", $this->mask_cnpj($this->dest->getElementsByTagName("CNPJ")->item(0)->nodeValue), "");
        //endereo rua numero complemento
        $endereco_emitente = $this->enderDest->getElementsByTagName("xLgr")->item(0)->nodeValue;
        $endereco_emitente.= (!empty($this->enderDest->getElementsByTagName("nro")->item(0)->nodeValue)) ? ", ".$this->enderEmit->getElementsByTagName("nro")->item(0)->nodeValue : null;
        $endereco_emitente.= (!empty($this->enderDest->getElementsByTagName("xCpl")->item(0)->nodeValue)) ? " - ".$this->enderEmit->getElementsByTagName("xCpl")->item(0)->nodeValue : null;
        $this->cellgtk('','','','','',"ENDEREO", "",utf8_decode($endereco_emitente));
        //dados da linha pronto
        $linha[1]=$this->linha[$this->gi]->getlinha();
        // linha emitente CNPJ ENDEREO
         $this->linhagtk("");

        //Bairro / Distrito
        $bairro_emitente = $this->enderDest->getElementsByTagName("xBairro")->item(0)->nodeValue;
        $this->cellgtk( 5.0,  84.6,  10.0, 43.0, "", "Bairro / Distrito", "", utf8_decode($bairro_emitente));
        //CEP
        $this->cellgtk('','','','','',"CEP:", "", utf8_decode($this->dest->getElementsByTagName("CEP")->item(0)->nodeValue), "");
        
        //dados da linha pronto
        $linha[2]=$this->linha[$this->gi]->getlinha();
        // 
         $this->linhagtk("");
        $endereco_emitente2= $this->enderDest->getElementsByTagName("cMun")->item(0)->nodeValue. " - ".$this->enderDest->getElementsByTagName("xMun")->item(0)->nodeValue;
        $UF= (!empty($this->enderDest->getElementsByTagName("UF")->item(0)->nodeValue)) ? "/".$this->enderDest->getElementsByTagName("UF")->item(0)->nodeValue : null;
        $this->cellgtk( '','','','','',"Municpio", "",  utf8_decode($endereco_emitente2));
        $this->cellgtk( '','','','','',"Fone", "", $this->enderDest->getElementsByTagName("fone")->item(0)->nodeValue);
//dados da linha pronto
$linha[3]=$this->linha[$this->gi]->getlinha();
// 
         $this->linhagtk("");
 	
 	
 	//UF 
 	$this->cellgtk('','','','','',"UF", "", $this->enderDest->getElementsByTagName("UF")->item(0)->nodeValue, "");
    //pais
    $this->cellgtk('','','','','',"PAIS", "", $this->enderDest->getElementsByTagName("xPais")->item(0)->nodeValue, "");
//dados da linha pronto
$linha[4]=$this->linha[$this->gi]->getlinha();
$this->linhagtk("");
//Inscrio Estadual  
 	$this->cellgtk('','','','','',"Inscrio Estadual ", "", utf8_decode($this->dest->getElementsByTagName("IE")->item(0)->nodeValue), "");
//Inscrio Estadual do Substituto Tributrio IEST
    $this->cellgtk('','','','','',"Inscrio SUFRAMA", "", utf8_decode($this->dest->getElementsByTagName("ISUF")->item(0)->nodeValue), "");
//dados da linha pronto
$linha[5]=$this->linha[$this->gi]->getlinha();

return $linha; //deveria ser por referencia
        }
     /**
     * Gera Pagina 2 Dados do Emitente 
     * @param	string   $xml
     * @param   string   $formato P=portrait L=landscape
     * @return
     * @access  public
     * @author Daniel B. Lemes
     *
     **/

    //pagina um do notebook
        Function pag2()
        {
        $this->linhagtk("Dados do Emitente");
        //Nome / Razo Social 
        $this->cellgtk('','','','','',"Nome / Razo Social", "", utf8_decode($this->emit->getElementsByTagName("xNome")->item(0)->nodeValue), "");
        //Nome fantasia
        $this->cellgtk('','','','','',"Nome Fantasia", "", utf8_decode($this->emit->getElementsByTagName("xFant")->item(0)->nodeValue), "");
        //dados da linha pronto
        $linha[0]=$this->linha[$this->gi]->getlinha();
        // linha emitente CNPJ ENDEREO
         $this->linhagtk("");
        //CNPJ
 	    $this->cellgtk('','','','','',"C.N.P.J.", "", $this->mask_cnpj($this->emit->getElementsByTagName("CNPJ")->item(0)->nodeValue), "");
        //endereo rua numero complemento
        $endereco_emitente = $this->enderEmit->getElementsByTagName("xLgr")->item(0)->nodeValue;
        $endereco_emitente.= (!empty($this->enderEmit->getElementsByTagName("nro")->item(0)->nodeValue)) ? ", ".$this->enderEmit->getElementsByTagName("nro")->item(0)->nodeValue : null;
        $endereco_emitente.= (!empty($this->enderEmit->getElementsByTagName("xCpl")->item(0)->nodeValue)) ? " - ".$this->enderEmit->getElementsByTagName("xCpl")->item(0)->nodeValue : null;
        $this->cellgtk('','','','','',"ENDEREO", "",utf8_decode($endereco_emitente));
        //dados da linha pronto
        $linha[1]=$this->linha[$this->gi]->getlinha();
        // linha emitente CNPJ ENDEREO
         $this->linhagtk("");

        //Bairro / Distrito
        $bairro_emitente = $this->enderEmit->getElementsByTagName("xBairro")->item(0)->nodeValue;
        $this->cellgtk( 5.0,  84.6,  10.0, 43.0, "", "Bairro / Distrito", "", utf8_decode($bairro_emitente));
        //CEP
        $this->cellgtk('','','','','',"CEP:", "", utf8_decode($this->emit->getElementsByTagName("CEP")->item(0)->nodeValue), "");
        
        //dados da linha pronto
        $linha[2]=$this->linha[$this->gi]->getlinha();
        // 
         $this->linhagtk("");
        $endereco_emitente2= $this->enderEmit->getElementsByTagName("cMun")->item(0)->nodeValue ." - ".$this->enderEmit->getElementsByTagName("xMun")->item(0)->nodeValue ;
        $UF= (!empty($this->enderEmit->getElementsByTagName("UF")->item(0)->nodeValue)) ? "/".$this->enderEmit->getElementsByTagName("UF")->item(0)->nodeValue : null;
        $this->cellgtk( '','','','','',"Municpio", "",  utf8_decode($endereco_emitente2));
        $this->cellgtk( '','','','','',"Fone", "", $this->enderEmit->getElementsByTagName("fone")->item(0)->nodeValue);
//dados da linha pronto
$linha[3]=$this->linha[$this->gi]->getlinha();
// 
         $this->linhagtk("");
 	
 	
 	//UF 
 	$this->cellgtk('','','','','',"UF", "", $this->enderEmit->getElementsByTagName("UF")->item(0)->nodeValue, "");
    //pais
    $this->cellgtk('','','','','',"PAIS", "", $this->enderEmit->getElementsByTagName("xPais")->item(0)->nodeValue, "");
//dados da linha pronto
$linha[4]=$this->linha[$this->gi]->getlinha();
$this->linhagtk("");
//Inscrio Estadual  
 	$this->cellgtk('','','','','',"Inscrio Estadual ", "", utf8_decode($this->emit->getElementsByTagName("IE")->item(0)->nodeValue), "");
//Inscrio Estadual do Substituto Tributrio IEST
    $this->cellgtk('','','','','',"Inscrio Estadual do Substituto Tributrio", "", utf8_decode($this->emit->getElementsByTagName("IEST")->item(0)->nodeValue), "");
//dados da linha pronto
$linha[5]=$this->linha[$this->gi]->getlinha();
$this->linhagtk("");
//Inscrio Municipal
$this->cellgtk('','','','','',"Inscrio Municipal", "", $this->emit->getElementsByTagName("IM")->item(0)->nodeValue, "");
//Municpio da Ocorrncia do Fato Gerador do ICMS cMunFG
$this->cellgtk('','','','','',"Municpio da Ocorrncia do Fato Gerador do ICMS", "", $this->emit->getElementsByTagName("cMunFG")->item(0)->nodeValue, "");
 	
//dados da linha pronto
$linha[6]=$this->linha[$this->gi]->getlinha();
        //EMISSO
        $this->linhagtk("");
//CNAE Fiscal
$this->cellgtk('','','','','',"CNAE Fiscal", "", $this->emit->getElementsByTagName("CNAE")->item(0)->nodeValue, "");
//dados da linha pronto
$linha[7]=$this->linha[$this->gi]->getlinha();
return $linha; //deveria ser por referencia

}

function pag4($vbox) {

        if (empty($this->xml)) {
            return false;
        }
		
        
 //Num. Descrio   Qtd.   Unidade Comercial   Valor (R$)

        $titulos = array('Action','Num.','Descrio','Qtd.','Unid.','Valor(R$)');
        $i = 0;
		$ii = 0;
        foreach ($this->det as $d) {
			
            $prod = $this->det->item($i)->getElementsByTagName("prod")->item(0);
            $imposto = $this->det->item($i)->getElementsByTagName("imposto")->item(0);
            $ICMS = $imposto->getElementsByTagName("ICMS")->item(0);
            $IPI  = $imposto->getElementsByTagName("IPI")->item(0);
            $vIPI = (!empty($IPI)) ? $IPI->getElementsByTagName("vIPI")->item(0)->nodeValue : 0;
			$pIPI = (!empty($IPI)) ? $IPI->getElementsByTagName("pIPI")->item(0)->nodeValue : 0;
            $NCM = (!empty($prod->getElementsByTagName("NCM")->item(0)->nodeValue)) ? $prod->getElementsByTagName("NCM")->item(0)->nodeValue : '';
            $MED = (!empty($prod->getElementsByTagName("med")->item(0)->nodeValue)) ? $prod->getElementsByTagName("med") : '';
            $ARMA = (!empty($prod->getElementsByTagName("arma")->item(0)->nodeValue)) ? $prod->getElementsByTagName("arma")->item(0)->nodeValue : '';
            
			$ii++;
            $this->item[$i][0]='0';
            $this->item[$i][1]=$i;//numero do item ou linha da nota //numero do item <nItem>
            $this->item[$i]["xProd"]= utf8_decode($prod->getElementsByTagName("xProd")->item(0)->nodeValue);
            $this->item[$i]["qCom"]= number_format($prod->getElementsByTagName("qCom")->item(0)->nodeValue, 4, ",", ".");
            $this->item[$i]["uCom"]= utf8_decode($prod->getElementsByTagName("uCom")->item(0)->nodeValue);
            $this->item[$i]["vUnCom"]= number_format($prod->getElementsByTagName("vUnCom")->item(0)->nodeValue, 4, ",", ".");

            $this->item[$i]["vUnTrib"]= number_format($prod->getElementsByTagName("vUnTrib")->item(0)->nodeValue, 4, ",", ".");
            $this->item[$i]["vProd"]= number_format($prod->getElementsByTagName("vProd")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["vBC"]= number_format($ICMS->getElementsByTagName("vBC")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["vDesc"]= number_format($prod->getElementsByTagName("vDesc")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["vFrete"]= number_format($prod->getElementsByTagName("vFrete")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["vSeg"]= number_format($prod->getElementsByTagName("vSeg")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["cProd"]= utf8_decode($prod->getElementsByTagName("cProd")->item(0)->nodeValue);
            $this->item[$i]["cEAN"]= utf8_decode($prod->getElementsByTagName("cEAN")->item(0)->nodeValue);
            $this->item[$i]["cEANTrib"]= utf8_decode($prod->getElementsByTagName("cEANTrib")->item(0)->nodeValue);
            $this->item[$i]["uTrib"]= utf8_decode($prod->getElementsByTagName("uTrib")->item(0)->nodeValue);
            $this->item[$i]["qTrib"]= utf8_decode($prod->getElementsByTagName("qTrib")->item(0)->nodeValue);

            $this->item[$i]['NCM']= $NCM;
            $this->item[$i]["genero"]= utf8_decode($prod->getElementsByTagName("genero")->item(0)->nodeValue);
            //dados do imposto
            $this->item[$i]['CST']=  $ICMS->getElementsByTagName("CST")->item(0)->nodeValue;
            $this->item[$i]['orig']=  $ICMS->getElementsByTagName("orig")->item(0)->nodeValue;
            $this->item[$i]['modBC']=  $ICMS->getElementsByTagName("modBC")->item(0)->nodeValue;
            $this->item[$i]['tICM']= $ICMS->getElementsByTagName("orig")->item(0)->nodeValue.$ICMS->getElementsByTagName("CST")->item(0)->nodeValue;
            $this->item[$i]['CFOP']= $prod->getElementsByTagName("CFOP")->item(0)->nodeValue;
            $this->item[$i]['EXTIPI']= $prod->getElementsByTagName("EXTIPI")->item(0)->nodeValue;
            $this->item[$i]["vICMS"]= number_format($ICMS->getElementsByTagName("vICMS")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["vIPI"]= number_format($vIPI, 2, ",", ".");
            $this->item[$i]["pICMS"]= number_format($ICMS->getElementsByTagName("pICMS")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["pICMSST"]= number_format($ICMS->getElementsByTagName("pICMSST")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["vICMSST"]= number_format($ICMS->getElementsByTagName("vICMSST")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["pMVAST"]= number_format($ICMS->getElementsByTagName("pMVAST")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["pRedBCST"]= number_format($ICMS->getElementsByTagName("pRedBCST")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]["vBCST"]= number_format($ICMS->getElementsByTagName("vBCST")->item(0)->nodeValue, 2, ",", ".");
            $this->item[$i]['modBCST']=  $ICMS->getElementsByTagName("modBCST")->item(0)->nodeValue;
            $this->item[$i]["pIPI"]= number_format($pIPI, 2, ",", ".");
            //obs para um mesmo item de medicamento podemos ter varios lotes logo isto pode repetir varias veses
            if(!empty($MED)){
            $ki=0;

            foreach ($MED as $k => $d) {
            $this->item[$i]['MED']['nLote'][$ki]=$MED->item($k)->getElementsByTagName("nLote")->item(0)->nodeValue;
            $this->item[$i]['MED']['qLote'][$ki]=$MED->item($k)->getElementsByTagName("qLote")->item(0)->nodeValue;
            $this->item[$i]['MED']['dFab'][$ki]=$MED->item($k)->getElementsByTagName("dFab")->item(0)->nodeValue;
            $this->item[$i]['MED']['dVal'][$ki]=$MED->item($k)->getElementsByTagName("dVal")->item(0)->nodeValue;
            $this->item[$i]['MED']['vPMC'][$ki]=$MED->item($k)->getElementsByTagName("vPMC")->item(0)->nodeValue;            
            $NLOTE=$this->item[$i]['MED']['nLote'][$k];
            $ki++;
            }
            }
            //obs para um mesmo item de armamento teremos varios numeros de serie varios lotes logo isto pode repetir varias veses
            if(!empty($ARMA)){
            $this->item[$i]['ARMA'][$ii]= number_format($pIPI, 2, ",", ".");
            }
            $i++;
            
        }
        
        $lista= new TDataListButtom($vbox, $this->item, $titulos);
       
       
    }

/**
     * Gera Pagina 5 Totais
     * @param	string   $xml
     * @param   string   $formato P=portrait L=landscape
     * @return
     * @access  public
     * @author Helder Mauricio Gomes Ferreira
     *
     **/

    //pagina cinco do notebook (totais)
        Function pag5()
        {
        $this->linhagtk("");
        //Nome / Razo Social 
        $this->cellgtk('','','','','',"", "", "TOTAIS", "");
        //dados da linha pronto
        $linha[]=$this->linha[$this->gi]->getlinha();
    //cria um titulo
    $this->linhagtk("");
    $label="ICMS";
    $cor="#aba0dc";
    $this->linha[$this->gi]->setcelltitle($label,$cor);//setcelltitle
    //fecha a linha
    $linha[]=$this->linha[$this->gi]->getlinha();

        $this->linhagtk("");
        //Base de Clculo ICMS
        $this->cellgtk('','','','','',"Base de Clculo ICMS", "", number_format($this->ICMSTot->getElementsByTagName("vBC")->item(0)->nodeValue, 2, ",", "."), "");
        //Valor do ICMS
        $this->cellgtk('','','','','',"Valor do ICMS", "", number_format($this->ICMSTot->getElementsByTagName("vICMS")->item(0)->nodeValue, 2, ",", "."), "");
        //Base de Clculo ICMS ST
         $this->cellgtk('','','','','',"Base de Clculo ICMS ST", "", number_format($this->ICMSTot->getElementsByTagName("vBCST")->item(0)->nodeValue, 2, ",", "."), "");
        //Valor ICMS Substituio 
        $this->cellgtk('','','','','',"Valor ICMS Substituio", "", number_format($this->ICMSTot->getElementsByTagName("vST")->item(0)->nodeValue, 2, ",", "."), "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();

        $this->linhagtk("");
        //Valor Total dos Produtos
        $this->cellgtk('','','','','',"Valor Total dos Produtos", "", number_format($this->ICMSTot->getElementsByTagName("vProd")->item(0)->nodeValue, 2, ",", "."), "");
        //Valor do frete
        $this->cellgtk('','','','','',"Valor do Frete ", "", number_format($this->ICMSTot->getElementsByTagName("vFrete")->item(0)->nodeValue, 2, ",", "."), "");
        //Valor do Seguro
         $this->cellgtk('','','','','',"Valor do Seguro", "", number_format($this->ICMSTot->getElementsByTagName("vSeg")->item(0)->nodeValue, 2, ",", "."), "");
        //Outras Despesas Acessrias 
        $this->cellgtk('','','','','',"Outras Despesas Acessrias", "", number_format($this->ICMSTot->getElementsByTagName("vDesc")->item(0)->nodeValue, 2, ",", "."), "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();

         $this->linhagtk("");
        //Valor Total do IPI 
        $this->cellgtk('','','','','',"Valor Total do IPI", "", number_format($this->ICMSTot->getElementsByTagName("vIPI")->item(0)->nodeValue, 2, ",", "."), "");
        //Valor Total da NFe
        $this->cellgtk('','','','','',"Valor Total da NFe", "", number_format($this->ICMSTot->getElementsByTagName("vNF")->item(0)->nodeValue, 2, ",", "."), "");
        //Valor Total Descontos
         $this->cellgtk('','','','','',"Valor Total Descontos", "", number_format($this->ICMSTot->getElementsByTagName("vDesc")->item(0)->nodeValue, 2, ",", "."), "");
        //Valor Total do II
        $this->cellgtk('','','','','',"Valor Total do II", "", number_format($this->ICMSTot->getElementsByTagName("vII")->item(0)->nodeValue, 2, ",", "."), "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();
        // 

        $this->linhagtk("");
        //Valor do PIS
        $this->cellgtk('','','','','',"Valor do PIS", "", number_format($this->ICMSTot->getElementsByTagName("vPIS")->item(0)->nodeValue, 2, ",", "."), "");
        //Valor da COFINS
        $this->cellgtk('','','','','',"  Valor da COFINS", "", number_format($this->ICMSTot->getElementsByTagName("vCOFINS")->item(0)->nodeValue, 2, ",", "."), "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();
        // 

        
return $linha; //deveria ser por referencia

}
/**
     * Gera Pagina 6 Dados do transporte
     * @param	string   $xml
     * @param   string   $formato P=portrait L=landscape
     * @return
     * @access  public
     * @author Helder Mauricio Gomes Ferreira
     *
     **/

    //pagina seis do notebook (Dados Do Transorte)
        Function pag6()
        {
        $this->linhagtk("");
        //Nome / Razo Social 
        $this->cellgtk('','','','','',"", "", "Dados do Transporte", "");
        //dados da linha pronto
        $linha[]=$this->linha[$this->gi]->getlinha();
 
  
    //cria um titulo
    $this->linhagtk("");
    $label="Modalidade do Frete";
    $cor="#aba0dc";
    $this->linha[$this->gi]->setcelltitle($label,$cor);//setcelltitle
    //fecha a linha
    $linha[]=$this->linha[$this->gi]->getlinha();
    //nova linha
    $this->linhagtk("");//linha sem label
    //cria a celula Modalidade do Frete
    switch ($this->transp->getElementsByTagName("modFrete")->item(0)->nodeValue)//modFrete
    {
        case "0":
            $texto="0 - por conta do emitente.";
            break;
        case "1":
            $texto="1 - por conta do destinatrio.";
            break;
            }
        $this->cellgtk('','','','','',  "", "",$texto, "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();
    //cria um titulo
    $this->linhagtk("");
    $label="TRANSPORTADOR";
    $cor="#aba0dc";
    $this->linha[$this->gi]->setcelltitle($label,$cor);//setcelltitle
    //fecha a linha
    $linha[]=$this->linha[$this->gi]->getlinha();
  
        $this->linhagtk("");
        //CNPJ trasportador
        $this->cellgtk('','','','','',"CNPJ", "", $this->mask_cnpj($this->transp->getElementsByTagName("CNPJ")->item(0)->nodeValue), "");
        //Cpf transportador
        $this->cellgtk('','','','','',"CPF", "", $this->mask_cpf($this->transp->getElementsByTagName("CPF")->item(0)->nodeValue), "");
        //Razo social/nome
         $this->cellgtk('','','','','',"Razo social/nome", "", $this->transp->getElementsByTagName("xNome")->item(0)->nodeValue, "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();
  
        $this->linhagtk("");
        //Inscrio Estadual 
        $this->cellgtk('','','','','',"Inscrio Estadual", "", $this->transp->getElementsByTagName("IE")->item(0)->nodeValue, "");
        //Endereo Completo 
        $this->cellgtk('','','','','',"Endereo Completo", "", $this->transp->getElementsByTagName("xEnder")->item(0)->nodeValue,"");
        //Municpio
         $this->cellgtk('','','','','',"Municpio", "", $this->transp->getElementsByTagName("xMun")->item(0)->nodeValue, "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();

         $this->linhagtk("");
        //UF
        //Inscrio Estadual 
        $this->cellgtk('','','','','',"Inscrio Estadual", "", $this->transp->getElementsByTagName("UF")->item(0)->nodeValue, "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();
        // 

               
return $linha; //deveria ser por referencia

}

 
/**
     * Gera Pagina 7 Dados de Cobrana
     * @param	string   $xml
     * @param   string   $formato P=portrait L=landscape
     * @return
     * @access  public
     * @author Helder Mauricio Gomes Ferreira
     *
     **/

    //pagina sete do notebook (Dados De Cobrana)
        Function pag7()
        {
        $this->linhagtk("");
        //Nome / Razo Social 
        $this->cellgtk('','','','','',"", "", "Dados de Cobrana ", "");
        //dados da linha pronto
        $linha[]=$this->linha[$this->gi]->getlinha();
 
  
    //cria um titulo
    $this->linhagtk("");
    $label="FATURA";
    $cor="#aba0dc";
    $this->linha[$this->gi]->setcelltitle($label,$cor);//setcelltitle
    //fecha a linha
    $linha[]=$this->linha[$this->gi]->getlinha();
      
        $this->linhagtk("");
        //Nmero
        $this->cellgtk('','','','','',"Nmero", "", $this->cobr->getElementsByTagName("nFat")->item(0)->nodeValue, "");
        //Valor Original
        $this->cellgtk('','','','','',"Valor Original", "", $this->cobr->getElementsByTagName("vOrig")->item(0)->nodeValue, "");
        //Valor do Desconto
         $this->cellgtk('','','','','',"Valor do Desconto", "", $this->cobr->getElementsByTagName("vDesc")->item(0)->nodeValue, "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();

         $this->linhagtk("");
        //Valor Lquido   
        $this->cellgtk('','','','','',"Valor Lquido", "", $this->cobr->getElementsByTagName("vLiq")->item(0)->nodeValue, "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();
    //cria um titulo
    $this->linhagtk("");
    $label="DUPLICATAS";
    $cor="#aba0dc";
    $this->linha[$this->gi]->setcelltitle($label,$cor);//setcelltitle
    //fecha a linha
    $linha[]=$this->linha[$this->gi]->getlinha();
    if(!empty($this->dup)){
            $k=0;
            
        foreach ($this->dup as $k => $d) {
                      
  
        $this->linhagtk("");
        //Nmero 
        $this->cellgtk('','','','','',"Nmero", "", $this->dup->item($k)->getElementsByTagName('nDup')->item(0)->nodeValue, "");
        //Vencimento
        $this->cellgtk('','','','','',"Vencimento", "", dmy2ymd($this->dup->item($k)->getElementsByTagName('dVenc')->item(0)->nodeValue),"");
        //Valor
         $this->cellgtk('','','','','',"Valor", "", "R$ ".number_format($this->dup->item($k)->getElementsByTagName('vDup')->item(0)->nodeValue, 2, ",", "."), "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();
        }
            }
        
        // 

               
return $linha; //deveria ser por referencia

}
/**
     * Gera Pagina 8 Informaes Adicionais 
     * @param	string   $xml
     * @param   string   $formato P=portrait L=landscape
     * @return
     * @access  public
     * @author Helder Mauricio Gomes Ferreira
     *
     **/

    //pagina oito do notebook (Informaes Adicionais)
        Function pag8()
        {
        $this->linhagtk("");
        //Informaes Adicionais
        $this->cellgtk('','','','','',"", "", "Informaes Adicionais", "");
        //dados da linha pronto
        $linha[]=$this->linha[$this->gi]->getlinha();
 
  
    //cria um titulo
    $this->linhagtk("");
    $label="INFORMAES ADICIONAIS DE INTERESSE DO FISCO";
    $cor="#aba0dc";
    $this->linha[$this->gi]->setcelltitle($label,$cor);//setcelltitle
    //fecha a linha
    $linha[]=$this->linha[$this->gi]->getlinha();
      
            if (is_object($this->infAdic)) {
            $infCpl     = $this->infAdic->getElementsByTagName("infCpl")->item(0)->nodeValue;
            $infAdFisco = $this->infAdic->getElementsByTagName("infAdFisco")->item(0)->nodeValue;
        }else{
         $infCpl     = "vazio";
         $infAdFisco = "vazio";
        }
        $this->linhagtk("");
        //Nmero
        $this->cellgtk('','','','','',"Descrio", "", $infAdFisco, "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();

    //cria um titulo
    $this->linhagtk("");
    $label="INFORMAES COMPLEMENTARES DE INTERESSE DO CONTRIBUINTE";
    $cor="#aba0dc";
    $this->linha[$this->gi]->setcelltitle($label,$cor);//setcelltitle
    //fecha a linha
    $linha[]=$this->linha[$this->gi]->getlinha();
    
        $this->linhagtk("");
        //Nmero
        $this->cellgtk('','','','','',"Descrio", "", $infCpl, "");
        // fecha a linha
        $linha[]=$this->linha[$this->gi]->getlinha();    
        // 

               
return $linha; //deveria ser por referencia

}
}

?>
