<?php
$window = new GtkWindow();
$window->set_size_request(400, 200);
$window->connect_simple('destroy', array('Gtk','main_quit'));
$window->add($vbox = new GtkVBox());

// display title
$title = new GtkLabel("Setup a button in GtkTreeView - Part 1");
$title->modify_font(new PangoFontDescription("Times New Roman Italic 10"));
$title->modify_fg(Gtk::STATE_NORMAL, GdkColor::parse("#0000ff"));
$title->set_size_request(-1, 40);
$vbox->pack_start($title, 0, 0);
$vbox->pack_start(new GtkLabel(), 0, 0);

// the 2D table
$data = array(
array('row0', 'item 42', 2, 3.1, 0),
array('row1', 'item 36', 20, 6.21, 0),
array('row2', 'item 21', 8, 9.36, 0),
array('row3', 'item 10', 11, 12.4, 0),
array('row4', 'item 7', 5, 15.5, 0),
array('row5', 'item 4', 17, 18.6, 0),
array('row6', 'item 3', 20, 21.73, 0));

$titulos = array('n','descrio','quant','valor unit','botao');

display_table($vbox, $data, $titulos);

$window->show_all();
Gtk::main();

function display_table($vbox, $data , $colunas) {

    // Set up a scroll window
    $scrolled_win = new GtkScrolledWindow();
    $scrolled_win->set_policy( Gtk::POLICY_AUTOMATIC,
        Gtk::POLICY_AUTOMATIC);
    $vbox->pack_start($scrolled_win);

    // Creates the list store
    if (defined("GObject::TYPE_STRING")) {
        $model = new GtkListStore( GObject::TYPE_LONG, GObject::TYPE_STRING, GObject::TYPE_STRING,
                    GObject::TYPE_LONG, GObject::TYPE_DOUBLE);
    } else {
        $model = new GtkListStore(Gtk::TYPE_STRING, Gtk::TYPE_STRING,
                    Gtk::TYPE_LONG, Gtk::TYPE_DOUBLE, Gtk::TYPE_LONG);
    }
    $field_header = $colunas;//nomes das colunas 
    $field_justification = array(0.0, 0.0, 0.5, 1.0, 0.0);

    // Creates the view to display the list store
    $view = new GtkTreeView($model);
    $scrolled_win->add($view);
    $view->connect('button-press-event', 'on_buttonpress', $model); // note 1
    $view->connect('button-release-event', 'on_buttonrelease', $model); // note 2

    // Creates the columns
    for ($col=0; $col<count($field_header); ++$col) {

        if ($col==0) {
            $cell_renderer = new GtkCellRendererPixbuf(); // note 3
            $column = new GtkTreeViewColumn();
            $column->pack_start($cell_renderer);
            $column->set_title($field_header[$col]);

        } else {

            $cell_renderer = new GtkCellRendererText();
            $cell_renderer->set_property("xalign", $field_justification[$col]);
            $column = new GtkTreeViewColumn($field_header[$col],
                $cell_renderer, 'text', $col);
            $column->set_alignment($field_justification[$col]);
            $column->set_sort_column_id($col);
            if ($col==1) $column->set_expand(1);
        }

        // set the header font and color
        $label = new GtkLabel($field_header[$col]);
        $label->modify_font(new PangoFontDescription("Arial Bold"));
        $label->modify_fg(Gtk::STATE_NORMAL, GdkColor::parse("#0000FF"));
        $column->set_widget($label);
        $label->show();

        // setup self-defined function to display alternate row color
        $column->set_cell_data_func($cell_renderer, "format_col", $col);
        $view->append_column($column);
    }

    // pupulates the data
    for ($row=0; $row<count($data); ++$row) {
        $values = array();
        for ($col=0; $col<count($data[$row]); ++$col) {
            $values[] = $data[$row][$col];
        }
        $model->append($values);
    }

    $selection = $view->get_selection();
    $selection->set_mode(Gtk::SELECTION_NONE);
}

// self-defined function to display alternate row color
function format_col($column, $cell, $model, $iter, $col_num) {
    if ($col_num==4) {
        if ($model[$iter][4]) { // note 4 se aqui tiver um 1
            $pixbuf = GdkPixbuf::new_from_file("button_click2.gif"); // note 4
        } else { //ou se tiver um 0
            $pixbuf = GdkPixbuf::new_from_file("button_click.gif"); // note 4
        }
        $cell->set_property('pixbuf', $pixbuf);
    }
    $path = $model->get_path($iter);
    $row_num = $path[0];
    $row_color = ($row_num%2==1) ? '#dddddd' : '#ffffff';
    $cell->set_property('cell-background', $row_color);
}

function on_buttonpress($view, $event, $model) {
    static $i=0;
    if ($event->button==1 && $event->type==4) {
        ++$i;
        // get the row and column
        $path_array = $view->get_path_at_pos($event->x, $event->y);
        $path = $path_array[0][0];
        $col = $path_array[1];
        $col_title = $col->get_title();
        clear_all_buttons($model);
        if ($col_title!='Action') return true;
        $model[$path][4] = 1;
        echo "$i: You have clicked the button for {$model[$path][0]}: {$model[$path][1]}\n"; // note 5
        return true;
    } else {
        clear_all_buttons($model);
        return false;
    }
}

function on_buttonrelease($view, $event, $model) {
    if ($event->button==1) {
        // get the row and column
        $path_array = $view->get_path_at_pos($event->x, $event->y);
        $path = $path_array[0][0];
        $col = $path_array[1];
        $col_title = $col->get_title();
        if ($col_title!='Action') {
            clear_all_buttons($model);
            return true;
        }
        $model[$path][4] = 0;
        return true;
    } else {
        clear_all_buttons($model);
        return false;
    }
}

function clear_all_buttons($model) { // note 6
    $n = $model->iter_n_children(null);
    for ($i=0; $i<$n; ++$i) {
        $iter = $model->get_iter($i);
        $model[$iter][4] = 0;
    }
}

/*
   1. Detectar clique no boto no treeview.
   2. Detectar liberao de boto no treeview.
   3. Configure a coluna onde a imagem do boto aparecer.
      Note que no h nenhuma imagem carregada neste momento no tempo.
      Respectivas imagens so carregadas na funo de exibio personalizado clula.
   4. Esta  a parte que define o boto de imagem, dependendo do estado do boto.
   5. Experimente clicar no boto em seqncia muito rpida,
      e tomar nota da sada na janela de comando.
      Voc ver que, embora o treeview no pode refletir que os cliques rpido o suficiente,
      todos os cliques de boto so de facto a ser capturado.
   6. Esta funo cuida do caso quando o usurio clica em um boto,
      detm sobre o boto do mouse, e afasta-se o boto. 
      Como no h sinal de liberao de boto, o boto ainda estar no 'clicked' estado.
      Esta funo serve para liberar todos os cliques no boto anteriores que no foram liberados. 
*/
?>