<?
/**
 * DANFE
 * dfadel
 * 22/07/2009
 *
 * Multiplas pginas, organizao rodap, cabealho
 * dlemes
 * Classe PDF_Code128 obtida em: http://www.fpdf.org/en/script/script88.php
 *
 * TODO: expandir para mltiplas folhas
 */

include_once(dirname(__FILE__).'/fpdf/fpdf.php');
include_once(dirname(__FILE__).'/fpdf/code128.php');

if (!defined('FPDF_FONTPATH')) {
    define('FPDF_FONTPATH','fpdf/font/');
}

if (!function_exists('dmy2ymd')) {
    function dmy2ymd($data) {
        if (!empty($data)) {
            $needle = "/";
            if (strstr($data, "-")) {
                $needle = "-";
            }
            $dt = explode($needle, $data);
            return "$dt[2]-$dt[1]-$dt[0]";
        }
    }
}

class danfe extends PDF_Code128{

    public $canhoto;   // se true, imprime campos do canhoto
    public $issqn;     // se true, imprime campos do issqn
    public $pdf;       // objeto fpdf()
    public $xml;       // string XML NFe
    public $logo;      // path para logomarca
    public $array_uf;  // usado para obter cdigo do estado do destinatario qdo em contingencia
    public $protocolo; // protocolo de autorizacao deve sair em infCpl
    public $data_hora; // data e hora de autorizacao devem sair em infCpl
	private $infNFe;
	private $ide;
	private $emit;
	private $dest;
	private $enderEmit;
	private $enderDest;
	private $det;
	private $cobr;
	private $dup;
	private $ICMSTot;
	private $transp;
	private $transporta;
	private $veicTransp;
	private $vols;
	private $infAdic;
	private $issqn_extra;

	
    function __construct($xml, $formato="P") {
		parent::__construct($formato, 'mm', 'A4');
		
		$dom = new DomDocument;
        $dom->loadXML($xml);
		$this->infNFe     = $dom->getElementsByTagName("infNFe")->item(0);
        $this->ide        = $dom->getElementsByTagName("ide")->item(0);
        $this->emit       = $dom->getElementsByTagName("emit")->item(0);
        $this->dest       = $dom->getElementsByTagName("dest")->item(0);
        $this->enderEmit  = $dom->getElementsByTagName("enderEmit")->item(0);
        $this->enderDest  = $dom->getElementsByTagName("enderDest")->item(0);
        $this->det        = $dom->getElementsByTagName("det");
        $this->cobr       = $dom->getElementsByTagName("cobr")->item(0);
        $this->dup        = $dom->getElementsByTagName('dup');
        $this->ICMSTot    = $dom->getElementsByTagName("ICMSTot")->item(0);
        $this->transp     = $dom->getElementsByTagName("transp")->item(0);
        $this->transporta = $dom->getElementsByTagName("transporta")->item(0);
        $this->veicTransp = $dom->getElementsByTagName("veicTransp")->item(0);
        $this->vols       = $dom->getElementsByTagName("vol");
        $this->infAdic    = $dom->getElementsByTagName("infAdic")->item(0);
		$this->canhoto   = true;
        $this->issqn     = false;
		//$this->PDF_Code128($formato, 'mm', 'A4'); 
		$this->AddPage();
		$this->xml       = $xml;
        $this->logomarca = 'logomarca.jpg';
        $this->array_uf  = array('SP' => 35);
    }


    function mask_cnpj($c) {
        return sprintf("%s.%s.%s/%s-%s", $c[0].$c[1], $c[2].$c[3].$c[4], $c[5].$c[6].$c[7], $c[8].$c[9].$c[10].$c[11], $c[12].$c[13]);
    }


    function mask_cpf($c) {
        return sprintf("%s.%s.%s-%s", $c[0].$c[1].$c[2], $c[3].$c[4].$c[5], $c[6].$c[7].$c[8], $c[9].$c[10]);
    }


    function mask_nnf($n) {
        $n = sprintf("%09s", $n);
        return sprintf("%s.%s.%s", $n[0].$n[1].$n[2], $n[3].$n[4].$n[5], $n[6].$n[7].$n[8]);
    }

    function mask_chave($c) {
        for ($i=0; $i<=strlen($c); ++$i) {
            $cf.= $c[$i-1];
            if ($i % 4 == 0) {
                $cf.= " ";
            }
        }
        return $cf;
    }


    function calcula_dv($chave35) {
        $multiplicadores = array(2,3,4,5,6,7,8,9);
        $i = 34;
        while ($i >= 0) {
            for ($m=0; $m<count($multiplicadores) && $i>=0; $m++) {
                $soma_ponderada+= $chave35[$i] * $multiplicadores[$m];
                $i--;
            }
        }
        $resto = $soma_ponderada % 11;
        if ($resto == '0' || $resto == '1') {
            $dv = 0;
        } else {
            $dv = 11 - $resto;
        }
        return $dv;
    }


    function linha($altura, $largura, $esquerda, $superior, $sbordas, $label="", $fonte="", $texto="", $tfonte="") {

        $bordas = array();
        for ($i=0; $i<strlen($sbordas); $i++) {
            $bordas[] = $sbordas[$i];
        }

        if (!$this->canhoto) {
            $superior-= 21;
        }

        // configura largura da linha N=negrito
        if (in_array("N", $bordas)) {
            $this->SetLineWidth(0.25);
        } else {
            $this->SetLineWidth(0.05);
        }

        if (in_array("T", $bordas)) {
            $this->line($esquerda, $superior, ($esquerda+$largura), $superior);
        }
        if (in_array("B", $bordas)) {
            $this->line($esquerda, ($superior+$altura), ($esquerda+$largura), ($superior+$altura));
        }
        if (in_array("L", $bordas)) {
            $this->line($esquerda, $superior, $esquerda, ($superior+$altura));
        }
        if (in_array("R", $bordas)) {
            $this->line(($esquerda+$largura), $superior, ($esquerda+$largura), ($superior+$altura));
        }

        // impressao das labels
        if (!empty($label)) {
            if (empty($fonte)) {
                $fonte = "Courier,B,5,L";
            }
            $f = split(",",$fonte);
            $this->SetFont($f[0], $f[1], $f[2]);
            $this->setXY($esquerda-($f[2]/10), $superior+($f[2]/4));
            $this->Cell($largura, 0, $label, 0, 0, $f[3]);
        }

        // impressao do texto
        if (!empty($texto)) {
            if (empty($tfonte)) {
                $tfonte = "Courier,,7,L";
            }
            $f = split(",",$tfonte);
            $this->SetFont($f[0], $f[1], $f[2]);
            $this->setXY($esquerda, $superior+5);
            $this->Cell($largura, 0, $texto, 0, 0, $f[3]);
        }
    }
	/**
     * Gera cabealho
     * @param	string   $xml
     * @param   string   $formato P=portrait L=landscape
     * @return
     * @access  public
     * @author Daniel B. Lemes
     *
     **/
	function Header(){
		$this->AliasNbPages('{total}');
		if ($this->canhoto) {
            // canhoto
            $this->linha(8.5, 150.0,  10.0,  4.8, "TBRL", "RECEBI(EMOS) DE ".utf8_decode($this->emit->getElementsByTagName("xNome")->item(0)->nodeValue).", OS PRODUTOS CONSTANTE DA NOTA FISCAL ELETRNICA INDICADA AO LADO,");
            $this->linha(5.5, 150.0,  10.0,  7.5,     "", "BEM COMO ATESTAMOS QUE OS MESMOS FORAM EXAMINADOS, SERVINDO O ACEITE DA PRESENTE PARA TODOS OS EFEITOS LEGAIS.");
            $this->linha( 17,  40.0, 160.0,  4.8, "TBRL", "NF-e", "Courier,B,7,C");
            $this->setXY(161, 11);
            $this->Cell(15, 2, "No.");
            $this->setXY(167, 9.8);
            $this->SetFillColor(230,230,230);
            $this->Cell(32, 3.8, "", 0, 0, "", true);
            $this->setXY(161, 17);
            $this->Cell(15, 0, "SRIE");

            $this->linha(8.5, 20, 168,  6.7, "", "", "", $this->mask_nnf($this->ide->getElementsByTagName('nNF')->item(0)->nodeValue),   "Courier,B,9,L");
            $this->linha(8.5, 20, 172, 11.9, "", "", "", $this->ide->getElementsByTagName('serie')->item(0)->nodeValue, "Courier,B,9,L");

            $this->linha(8.5,    40, 10.0, 13.3, "TBRL", "DATA DE RECEBIMENTO");
            $this->linha(8.5,   110, 50.0, 13.3, "TBRL", "IDENTIFICAO E ASSINATURA DO RECEBEDOR");

            $this->extra = 0;

        } else {
            $this->extra = 21;
        }


        $chave_acesso = str_replace('NFe', '', $this->infNFe->getAttribute("Id"));
        $this->SetFillColor(0,0,0);
        $this->Code128(125, 26.8, $chave_acesso, 70, 12);

        // dados da nfe
        $this->linha(39.2,  84.6,  10.0, 25.4, "B");    // identificacao emitente/logo
        if (!empty($this->logomarca) && is_file($this->logomarca)) {
            $this->Image($this->logomarca, 11, 28-$this->extra, 0, 10, 'jpeg');
        }
        $this->linha( 5.0,  84.6,  10.0, 40.0, "", "", "", utf8_decode($this->emit->getElementsByTagName("xNome")->item(0)->nodeValue), "Courier,B,7,L");
        $endereco_emitente = $this->enderEmit->getElementsByTagName("xLgr")->item(0)->nodeValue;
        $endereco_emitente.= (!empty($this->enderEmit->getElementsByTagName("nro")->item(0)->nodeValue)) ? ", ".$this->enderEmit->getElementsByTagName("nro")->item(0)->nodeValue : null;
        $endereco_emitente.= (!empty($this->enderEmit->getElementsByTagName("xCpl")->item(0)->nodeValue)) ? " - ".$this->enderEmit->getElementsByTagName("xCpl")->item(0)->nodeValue : null;
        $this->linha( 5.0,  84.6,  10.0, 43.0, "", "", "", utf8_decode($endereco_emitente));
        $endereco_emitente2 = $this->enderEmit->getElementsByTagName("xBairro")->item(0)->nodeValue;
        $endereco_emitente2.= (!empty($this->enderEmit->getElementsByTagName("xMun")->item(0)->nodeValue)) ? " - ".$this->enderEmit->getElementsByTagName("xMun")->item(0)->nodeValue : null;
        $endereco_emitente2.= (!empty($this->enderEmit->getElementsByTagName("UF")->item(0)->nodeValue)) ? "/".$this->enderEmit->getElementsByTagName("UF")->item(0)->nodeValue : null;
        $this->linha( 5.0,  84.6,  10.0, 46.0, "", "", "", utf8_decode($endereco_emitente2));
        $this->linha( 5.0,  84.6,  10.0, 49.0, "", "", "", "CEP: ".utf8_decode($this->emit->getElementsByTagName("CEP")->item(0)->nodeValue)." - FONE: ".utf8_decode($this->emit->getElementsByTagName("fone")->item(0)->nodeValue));
        

        if ($this->ide->getElementsByTagName("tpEmis")->item(0)->nodeValue != 1) {

            // contingencia

            $this->SetTextColor(170,170,170);
            $this->linha( 5.0, 190.0,  10.0, 120.0, "", "", "", "DANFE em Contingncia",   "Courier,B,30,C");
            $this->linha( 5.0, 190.0,  10.0, 140.0, "", "", "", "Impresso em decorrncia", "Courier,B,30,C");
            $this->linha( 5.0, 190.0,  10.0, 160.0, "", "", "", "de problemas tcnicos",   "Courier,B,30,C");
            $this->SetTextColor(0,0,0);

            $dados_nfe = $this->array_uf[$this->enderDest->getElementsByTagName("UF")->item(0)->nodeValue];
            $dados_nfe.= $this->ide->getElementsByTagName("tpEmis")->item(0)->nodeValue;
            $dados_nfe.= $this->dest->getElementsByTagName("CNPJ")->item(0)->nodeValue;
            $dados_nfe.= sprintf("%014s", str_replace(',', '', number_format($this->ICMSTot->getElementsByTagName("vNF")->item(0)->nodeValue, 2, ",", "")));
            $dados_nfe.= 1; // ICMSp
            $dados_nfe.= 2; // ICMSs
            $data_emissao = dmy2ymd($this->ide->getElementsByTagName("dEmi")->item(0)->nodeValue);
            $dados_nfe.= $data_emissao[0].$data_emissao[1];
            $dados_nfe.= $this->calcula_dv($dados_nfe);

            $this->Code128(125, 51.2, $dados_nfe, 70, 12); // codigo de barras

            $this->linha(14.8,    80, 120.0,  49.8,  "BTRL", ""); // codigo de barras dos dados
            $this->linha( 8.5,    80, 120.0,  64.6,  "BTRL",  "DADOS DA NF-e", "", $this->mask_chave($dados_nfe), "Courier,B,6.5,L");

        } else {

            // normal

            $prot_data_hora = $this->protocolo." ".$this->data_hora;
            $this->linha(14.8,    80, 120.0,  49.8,  "BTRL", "", "", "Consulta de autenticidade no portal nacional");
            $this->linha(14.8,    80, 120.0,  52.8,      "", "", "", "da NF-e www.nfe.fazenda.gov.br/portal ou");
            $this->linha(14.8,    80, 120.0,  55.8,      "", "", "", "no site da Sefaz Autorizadora");
            $this->linha( 8.5,    80, 120.0,  64.6,  "BTRL",  "PROTOCOLO DE AUTORIZAO DE USO", "", $prot_data_hora, "Courier,B,7,C");
        
        }


        // se for ambiente de homologao, escreve SEM VALOR FISCAL
        if ($this->ide->getElementsByTagName("tpAmb")->item(0)->nodeValue == 2) {
            $this->SetTextColor(170,170,170);
            $this->linha( 5.0, 190.0,  10.0, 210.0, "", "", "", "SEM VALOR FISCAL", "Courier,B,50,C");
            $this->SetTextColor(0,0,0);
        }


        $this->linha(39.2,  25.4,  94.6,  25.4,  "BTRL", "DANFE",              "Courier,B,12,C"); // DANFE
        $this->linha(39.2,  25.4,  94.6,    31,      "", "DOCUMENTO AUXILIAR", "Courier,B,6,C");
        $this->linha(39.2,  25.4,  94.6,    33,      "", "DA NOTA FISCAL",     "Courier,B,6,C");
        $this->linha(39.2,  25.4,  94.6,    35,      "", "ELETRNICA",         "Courier,B,6,C");

        $this->linha(39.2,  25.4,  95.6,    42,      "", "0 - ENTRADA",        "Courier,B,6,L");
        $this->linha(39.2,  25.4,  95.6,    45,      "", "1 - SADA",          "Courier,B,6,L");
        $this->linha(   7,     5,   113,    41,  "BTRL", "", "", $this->ide->getElementsByTagName('tpNF')->item(0)->nodeValue, "Courier,B,10,C");

        $this->linha(39.2,  25.4,  95.6,    52,      "", "No.",   "Courier,B,6,L");
        $this->linha(39.2,  25.4,  95.6,    56,      "", "SRIE", "Courier,B,5,L");
        $this->linha(39.2,  25.4,  95.6,    60,      "", "FOLHA", "Courier,B,5,L");
        $this->linha(39.2,  25.4,   101,  48.5,      "", "", "", $this->mask_nnf($this->ide->getElementsByTagName('nNF')->item(0)->nodeValue));
        $this->linha(39.2,  25.4,   102,  52.2,      "", "", "", $this->ide->getElementsByTagName('serie')->item(0)->nodeValue);
        $this->linha(39.2,  25.4,   102,  56.0,      "", "", "", $this->PageNo().' de {total}');

        $this->linha(14.8,    80, 120.0,  25.4,  "BTRL"); // codigo de barras da chave
        $this->linha( 9.6,    80, 120.0,  40.2,  "BTRL",  "CHAVE DE ACESSO", "", $this->mask_chave($chave_acesso), "Courier,B,6.5,L");
        $this->linha( 8.5, 110.0,  10.0,  64.6,  "BTRL",  "NATUREZA DA OPERAO", "", utf8_decode($this->ide->getElementsByTagName("natOp")->item(0)->nodeValue));

        $this->linha( 8.5,  63.4,  10.0,  73.1,  "BTRL", "INSCRIO ESTADUAL", "", utf8_decode($this->emit->getElementsByTagName("IE")->item(0)->nodeValue));
        $this->linha( 8.5,  63.3,  73.4,  73.1,  "BTRL", "INSCRIO ESTADUAL DO SUBST. TRIB.", "", utf8_decode($this->emit->getElementsByTagName("IEST")->item(0)->nodeValue));
        $this->linha( 8.5,  63.3, 136.7,  73.1,  "BTRL", "C.N.P.J.", "", $this->mask_cnpj($this->emit->getElementsByTagName("CNPJ")->item(0)->nodeValue));
		
		// destinatario/remetente
        $this->linha( 4.2,    33,  10.0,  82.6,      "", "DESTINATRIO/REMETENTE", "Courier,B,6,L");
        $this->linha( 8.5, 110.0,  10.0,  85.8,  "BTRL", "NOME/RAZO SOCIAL","", utf8_decode($this->dest->getElementsByTagName("xNome")->item(0)->nodeValue));
        $this->dest_doc = (!empty($this->dest->getElementsByTagName("CNPJ")->item(0)->nodeValue)) ? $this->mask_cnpj($this->dest->getElementsByTagName("CNPJ")->item(0)->nodeValue) : $this->mask_cpf($this->dest->getElementsByTagName("CPF")->item(0)->nodeValue);
        $this->linha( 8.5,  51.0, 120.0,  85.8, "BTRLN", "C.N.P.J./C.P.F.","",   $this->dest_doc);
        $this->linha( 8.5,  29.0,   171,  85.8,  "BTRL", "DATA DA EMISSO","",   dmy2ymd($this->ide->getElementsByTagName("dEmi")->item(0)->nodeValue));
        $this->dest_ender = utf8_decode($this->enderDest->getElementsByTagName("xLgr")->item(0)->nodeValue);
        $this->dest_ender.= (!empty($this->enderDest->getElementsByTagName("nro")->item(0)->nodeValue)) ? ", ".utf8_decode($this->enderDest->getElementsByTagName("nro")->item(0)->nodeValue) : null;
        $this->linha( 8.5,  91.0,  10.0,  94.3,  "BTRL", "ENDEREO","",          $this->dest_ender);
        $this->linha( 8.5,  45.0, 101.0,  94.3,  "BTRL", "BAIRRO/DISTRITO","",   utf8_decode($this->enderDest->getElementsByTagName("xBairro")->item(0)->nodeValue));
        $this->linha( 8.5,  25.0, 146.0,  94.3,  "BTRL", "CEP","",               utf8_decode($this->enderDest->getElementsByTagName("CEP")->item(0)->nodeValue));
        $this->linha( 8.5,  29.0,   171,  94.3, "BTRLN", "DATA DA SADA/ENTRADA","",dmy2ymd($this->ide->getElementsByTagName("dSaiEnt")->item(0)->nodeValue));
        $this->linha( 8.5,  64.0,  10.0, 102.8,  "BTRL", "MUNICPIO","",         utf8_decode($this->enderDest->getElementsByTagName("xMun")->item(0)->nodeValue));
        $this->linha( 8.5,  35.0,  74.0, 102.8,  "BTRL", "FONE/FAX","",          utf8_decode($this->enderDest->getElementsByTagName("fone")->item(0)->nodeValue));
        $this->linha( 8.5,  11.0, 109.0, 102.8,  "BTRL", "UF","",                utf8_decode($this->enderDest->getElementsByTagName("UF")->item(0)->nodeValue));
        $this->linha( 8.5,  51.0, 120.0, 102.8,  "BTRL", "INSCRIO ESTADUAL","",utf8_decode($this->dest->getElementsByTagName("IE")->item(0)->nodeValue));
        $this->linha( 8.5,  29.0,   171, 102.8, "BTRLN", "HORA DA SADA","",     date("H:i:s")); // BUG: como esta TAG no existe no XML, obter hora atual

        // faturas/duplicatas
        $this->linha( 4.2,    10,  10.0, 111.9,      "", "FATURA/DUPLICATAS", "Courier,B,6,L");
        // TODO: melhorar fatura aqui tb
        $this->dups = "";
        foreach ($this->dup as $k => $d) {
            $this->dups.= $this->dup->item($k)->getElementsByTagName('nDup')->item(0)->nodeValue." - ";
            $this->dups.= dmy2ymd($this->dup->item($k)->getElementsByTagName('dVenc')->item(0)->nodeValue);
            $this->dups.= " - R$ ".number_format($this->dup->item($k)->getElementsByTagName('vDup')->item(0)->nodeValue, 2, ",", ".")."    ";
        }
        $this->linha( 8.5, 190.0,  10.0, 115.1,  "BTRL", "", "", utf8_decode($this->dups));

        // calculo do imposto
        $this->linha( 4.2,    56,  10.0, 124.6,      "", "CLCULO DO IMPOSTO", "Courier,B,6,L");
        $this->linha( 8.5,  37.5,  10.0, 127.8,  "BTRL", "BASE DE CLCULO DO ICMS",     "", number_format($this->ICMSTot->getElementsByTagName("vBC")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R");
        $this->linha( 8.5,  37.5,  47.5, 127.8,  "BTRL", "VALOR DO ICMS",               "", number_format($this->ICMSTot->getElementsByTagName("vICMS")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R" );
        $this->linha( 8.5,  37.5,  85.0, 127.8,  "BTRL", "BASE DE CLCULO DO ICMS ST",  "", number_format($this->ICMSTot->getElementsByTagName("vBCST")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R" );
        $this->linha( 8.5,  37.5, 122.5, 127.8,  "BTRL", "VALOR DO ICMS ST",            "", number_format($this->ICMSTot->getElementsByTagName("vST")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R" );
        $this->linha( 8.5,  40.0, 160.0, 127.8,  "BTRL", "VALOR TOTAL DOS PRODUTOS",    "", number_format($this->ICMSTot->getElementsByTagName("vProd")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R" );
        $this->linha( 8.5,  30.0,  10.0, 136.3,  "BTRL", "VALOR DO FRETE",              "", number_format($this->ICMSTot->getElementsByTagName("vFrete")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R" );
        $this->linha( 8.5,  30.0,  40.0, 136.3,  "BTRL", "VALOR DO SEGURO",             "", number_format($this->ICMSTot->getElementsByTagName("vSeg")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R" );
        $this->linha( 8.5,  30.0,  70.0, 136.3,  "BTRL", "DESCONTO",                    "", number_format($this->ICMSTot->getElementsByTagName("vDesc")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R" );
        $this->linha( 8.5,  30.0, 100.0, 136.3,  "BTRL", "OUTRAS DESPESAS ACESSRIAS",  "", number_format($this->ICMSTot->getElementsByTagName("vOutro")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R" );
        $this->linha( 8.5,  30.0, 130.0, 136.3,  "BTRL", "VALOR DO IPI",                "", number_format($this->ICMSTot->getElementsByTagName("vIPI")->item(0)->nodeValue, 2, ",", "."), "Courier,,7,R" );
        $this->linha( 8.5,  40.0, 160.0, 136.3, "BTRLN", "VALOR TOTAL DA NOTA",         "", number_format($this->ICMSTot->getElementsByTagName("vNF")->item(0)->nodeValue, 2, ",", "."), "Courier,B,8,R" );

        // transportador/volumes transportados
        $this->linha( 4.2,    52,  10.0, 145.8,      "", "TRANSPORTADOR/VOLUMES TRANSPORTADOS", "Courier,B,6,L");
        if (is_object($this->transporta)) {
            $this->transp_doc     = (!empty($this->transporta->getElementsByTagName("CNPJ")->item(0)->nodeValue)) ? $this->mask_cnpj($this->transporta->getElementsByTagName("CNPJ")->item(0)->nodeValue) : $this->mask_cpf($this->transporta->getElementsByTagName("CPF")->item(0)->nodeValue);
            $this->transp_xNome   = utf8_decode($this->transporta->getElementsByTagName("xNome")->item(0)->nodeValue);
            $this->transp_xEnder  = utf8_decode($this->transporta->getElementsByTagName("xEnder")->item(0)->nodeValue);
            $this->transp_xMun    = utf8_decode($this->transporta->getElementsByTagName("xMun")->item(0)->nodeValue);
            $this->transp_UF      = utf8_decode($this->transporta->getElementsByTagName("UF")->item(0)->nodeValue);
            $this->transp_IE      = utf8_decode($this->transporta->getElementsByTagName("IE")->item(0)->nodeValue);
        }
        if (is_object($this->veicTransp)) {
            $veic_RNTC      = utf8_decode($this->veicTransp->getElementsByTagName("RNTC")->item(0)->nodeValue);
            $veic_placa     = utf8_decode($this->veicTransp->getElementsByTagName("placa")->item(0)->nodeValue);
            $veic_UF        = utf8_decode($this->veicTransp->getElementsByTagName("UF")->item(0)->nodeValue);
        }
        $this->linha( 8.5,  80.0,  10.0,   149,  "BTRL", "RAZO SOCIAL",        "", $this->transp_xNome);
        $this->linha( 8.5,  26.0,  90.0,   149,  "BTRL", "FRETE POR CONTA DE",  "");
        $this->linha( 8.5,  26.0,  90.0,   152,      "", "1 - EMITENTE",  "");
        $this->linha( 8.5,  26.0,  90.0,   154,      "", "2 - DESTINAT.",  "");
        $this->linha( 3.5,   4.0, 110.0, 152.5,  "BTRL", "");
        $this->linha( 3.5,   4.0, 110.2, 149.2,      "", "",                    "", $this->transp->getElementsByTagName("modFrete")->item(0)->nodeValue+1);
        $this->linha( 8.5,  16.0, 116.0,   149,  "BTRL", "CDIGO ANTT",         "", $veic_RNTC);
        $this->linha( 8.5,  21.0, 132.0,   149,  "BTRL", "PLACA DO VECULO",    "", $veic_placa);
        $this->linha( 8.5,   8.0, 153.0,   149,  "BTRL", "UF",                  "", $veic_UF);
        $this->linha( 8.5,  39.0, 161.0,   149,  "BTRL", "C.N.P.J./C.P.F.",     "", $this->transp_doc);
        $this->linha( 8.5,  80.0,  10.0, 157.5,  "BTRL", "ENDEREO",            "", $this->transp_xEnder);
        $this->linha( 8.5,  63.0,  90.0, 157.5,  "BTRL", "MUNICPIO",           "", $this->transp_xMun);
        $this->linha( 8.5,   8.0, 153.0, 157.5,  "BTRL", "UF",                  "", $this->transp_UF);
        $this->linha( 8.5,  39.0, 161.0, 157.5,  "BTRL", "INSCRIO ESTADUAL",  "", $this->transp_IE);

        // faz somatorios/concatenacoes dos volumes e coloca nos campos
        foreach ($this->vols as $key => $v) {
            $barra   = ($key != 0) ? "/" : "";
            $qVol   += $v->getElementsByTagName("qVol")->item(0)->nodeValue;
            $esp    .= $barra.$v->getElementsByTagName("esp")->item(0)->nodeValue;
            $marca  .= $barra.$v->getElementsByTagName("marca")->item(0)->nodeValue;
            $nVol   .= $barra.$v->getElementsByTagName("nVol")->item(0)->nodeValue;
            $pesoB  += $v->getElementsByTagName("pesoB")->item(0)->nodeValue;
            $pesoL  += $v->getElementsByTagName("pesoL")->item(0)->nodeValue;
        }
        $this->linha( 8.5,  26.0,  10.0,   166,  "BTRL", "QUANTIDADE",          "", number_format($qVol, 2, ",", "."), "Courier,,7,R");
        $this->linha( 8.5,  27.0,  36.0,   166,  "BTRL", "ESPCIE",             "", utf8_decode($esp));
        $this->linha( 8.5,  27.0,  63.0,   166,  "BTRL", "MARCA",               "", utf8_decode($marca));
        $this->linha( 8.5,  46.0,  90.0,   166,  "BTRL", "NUMERAO",           "", utf8_decode($nVol));
		$this->linha( 8.5,  32.0,   136,   166,  "BTRL", "PESO BRUTO",          "", !empty($pesoB)?number_format($pesoB, 3, ",", "."):"", "Courier,,7,R");
		$this->linha( 8.5,  32.0, 168.0,   166,  "BTRL", "PESO LQUIDO",        "", !empty($pesoL)?number_format($pesoL, 3, ",", "."):"", "Courier,,7,R");

        $this->issqn_extra = 0;
        if (!$this->issqn) {
            $this->issqn_extra = 12.7;
        }

	}
	
	function cabecalhoProdutos(){
			$this->linha( 4.2+$this->extra+$this->issqn_extra,    40,  10.0, 175.5,     "", "DADOS DOS PRODUTOS/SERVIOS", "Courier,B,6,L");
			$this->linha(65.0+$this->extra+$this->issqn_extra, 190.0,  10.0, 178.7, "BTRL", "");
			$this->linha(2.6, 190.0, 10.0, 178.7, "BTRL",  "");
			$this->linha(65.0+$this->extra+$this->issqn_extra,  15.0,  10.0, 178.7, "BTRL", "CDIGO",    "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,  62.0,  25.0, 178.7, "BTRL", "DESCRIO", "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,   9.5,  87.0, 178.7, "BTRL", "NCM/SH",    "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,   4.5,  96.5, 178.7, "BTRL", "CST",       "Courier,,5,L");
			$this->linha(65.0+$this->extra+$this->issqn_extra,   5.5, 101.0, 178.7, "BTRL", "CFOP",      "Courier,,5,L");
			$this->linha(65.0+$this->extra+$this->issqn_extra,   5.0, 106.5, 178.7, "BTRL", " UN.",      "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,  13.0, 111.5, 178.7, "BTRL", "QUANT.",    "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,  13.0, 124.5, 178.7, "BTRL", "V.UNIT.",   "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,  14.0, 137.5, 178.7, "BTRL", "V.TOTAL",   "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,  12.5, 151.5, 178.7, "BTRL", "BC.ICMS",   "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,  11.0, 164.0, 178.7, "BTRL", "V.ICMS",    "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,  11.0, 175.0, 178.7, "BTRL", "V.IPI",     "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,   7.0, 186.0, 178.7, "BTRL", "%ICMS",     "Courier,,5,C");
			$this->linha(65.0+$this->extra+$this->issqn_extra,   7.0, 193.0, 178.7, "BTRL", "%IPI",      "Courier,,5,C");
		
		}

	
    function gera() {

        if (empty($this->xml)) {
            return false;
        }
		
        // dados dos produtos/servicos
		$this->cabecalhoProdutos();
        $i = 0;
		$ii = 0;
        foreach ($this->det as $d) {
			if($ii==32){
				$this->AddPage();
				$this->cabecalhoProdutos();
				$ii=0;
			}
			//Line(float x1, float y1, float x2, float y2)
			//Cell(float w [, float h [, string txt [, mixed border [, int ln [, string align [, boolean fill [, mixed link]]]]]]])
            $prod = $this->det->item($i)->getElementsByTagName("prod")->item(0);
            $imposto = $this->det->item($i)->getElementsByTagName("imposto")->item(0);
            $ICMS = $imposto->getElementsByTagName("ICMS")->item(0);
            $IPI  = $imposto->getElementsByTagName("IPI")->item(0);
            $vIPI = (!empty($IPI)) ? $IPI->getElementsByTagName("vIPI")->item(0)->nodeValue : 0;
			$pIPI = (!empty($IPI)) ? $IPI->getElementsByTagName("pIPI")->item(0)->nodeValue : 0;
            $NCM = (!empty($prod->getElementsByTagName("NCM")->item(0)->nodeValue)) ? $prod->getElementsByTagName("NCM")->item(0)->nodeValue : '';
            $i++;
			$ii++;
            $this->linha(65.0+$this->extra+$this->issqn_extra,  15.0,  10.0, 178.9+($ii*2.3), "", utf8_decode($prod->getElementsByTagName("cProd")->item(0)->nodeValue),     "Courier,,5,L");
            $this->linha(65.0+$this->extra+$this->issqn_extra,  62.0,  25.0, 178.9+($ii*2.3), "", utf8_decode($prod->getElementsByTagName("xProd")->item(0)->nodeValue),     "Courier,,5,L");
            $this->linha(65.0+$this->extra+$this->issqn_extra,   9.5,  87.0, 178.9+($ii*2.3), "", $NCM,                    "Courier,,5,L");
            $this->linha(65.0+$this->extra+$this->issqn_extra,   4.5,  96.5, 178.9+($ii*2.3), "", $ICMS->getElementsByTagName("orig")->item(0)->nodeValue.$ICMS->getElementsByTagName("CST")->item(0)->nodeValue, "Courier,,5,L");
            $this->linha(65.0+$this->extra+$this->issqn_extra,   5.5, 101.0, 178.9+($ii*2.3), "", $prod->getElementsByTagName("CFOP")->item(0)->nodeValue,                               "Courier,,5,L");
            $this->linha(65.0+$this->extra+$this->issqn_extra,   5.0, 106.5, 178.9+($ii*2.3), "", utf8_decode($prod->getElementsByTagName("uCom")->item(0)->nodeValue),                  "Courier,,5,C");
            $this->linha(65.0+$this->extra+$this->issqn_extra,  13.5, 111.5, 178.9+($ii*2.3), "", number_format($prod->getElementsByTagName("qCom")->item(0)->nodeValue, 4, ",", "."),   "Courier,,5,R");
            $this->linha(65.0+$this->extra+$this->issqn_extra,  13.5, 124.5, 178.9+($ii*2.3), "", number_format($prod->getElementsByTagName("vUnCom")->item(0)->nodeValue, 4, ",", "."), "Courier,,5,R");
            $this->linha(65.0+$this->extra+$this->issqn_extra,  14.5, 137.5, 178.9+($ii*2.3), "", number_format($prod->getElementsByTagName("vProd")->item(0)->nodeValue, 2, ",", "."),  "Courier,,5,R");
            $this->linha(65.0+$this->extra+$this->issqn_extra,  13.0, 151.5, 178.9+($ii*2.3), "", number_format($ICMS->getElementsByTagName("vBC")->item(0)->nodeValue, 2, ",", "."),    "Courier,,5,R");
            $this->linha(65.0+$this->extra+$this->issqn_extra,  11.5, 164.0, 178.9+($ii*2.3), "", number_format($ICMS->getElementsByTagName("vICMS")->item(0)->nodeValue, 2, ",", "."),  "Courier,,5,R");
            $this->linha(65.0+$this->extra+$this->issqn_extra,  11.5, 175.0, 178.9+($ii*2.3), "", number_format($vIPI, 2, ",", "."),    "Courier,,5,R");
            $this->linha(65.0+$this->extra+$this->issqn_extra,   7.5, 186.0, 178.9+($ii*2.3), "", number_format($ICMS->getElementsByTagName("pICMS")->item(0)->nodeValue, 2, ",", "."),  "Courier,,5,R");
            $this->linha(65.0+$this->extra+$this->issqn_extra,   7.5, 193.0, 178.9+($ii*2.3), "", number_format($pIPI, 2, ",", "."),    "Courier,,5,R");
        }

        //$this->SetDisplayMode(70);
        $this->Output();
        //return $this->pdf;
    }
	/**
     * Gera Rodap
     * @return
     * @access  public
     * @author Daniel B. Lemes
     *
     **/
	function Footer(){
		 if ($this->issqn) {
            // calculo do issqn
            $this->linha(4.2, 23.0,  10.0, 244.3+$this->extra,     "", "CLCULO DO ISSQN", "Courier,B,6,L");
            $this->linha(8.5, 46.0,  10.0, 247.9+$this->extra, "BTRL", "INSCRIO MUNICIPAL");
            $this->linha(8.5, 47.0,  56.0, 247.9+$this->extra, "BTRL", "VALOR TOTAL DOS SERVIOS");
            $this->linha(8.5, 47.0, 103.0, 247.9+$this->extra, "BTRL", "BASE DE CLCULO DO ISSQN");
            $this->linha(8.5, 50.0, 150.0, 247.9+$this->extra, "BTRL", "VALOR DO ISSQN");
        }

        // dados adicionais
        $this->linha( 4.2,  23.0,  10.0, 257.4+$this->extra,      "", "DADOS ADICIONAIS", "Courier,B,6,L");

        $this->linha(30.7, 113.0,  10.0, 260.6+$this->extra,  "BTRL", "INFORMAES COMPLEMENTARES");
        $this->linha(30.7,  77.0, 123.0, 260.6+$this->extra,  "BTRL", "RESERVADO AO FISCO");


        $this->setFont("Courier", "", "6");
        $this->SetAutopagebreak(false); 


        if (is_object($this->infAdic)) {
            $infCpl     = $this->infAdic->getElementsByTagName("infCpl")->item(0)->nodeValue;
            $infAdFisco = $this->infAdic->getElementsByTagName("infAdFisco")->item(0)->nodeValue;
        }

        // IMPRIME infCpl
        for ($i=0; $i<=strlen($infCpl); $i++) {
            $txt.= $infCpl[$i];
            if ($this->GetStringWidth($txt) >= 110 || $i >= strlen($infCpl)) {
                $this->setXY(10, 265+$this->extra+($l*3));
                $this->Cell(113, 0, $txt, 0, 0, 'L');
                $txt = '';
                $l++;
            }
        }

        // IMPRIME infAdFisco
        $l = 0;
        for ($i=0; $i<=strlen($infAdFisco); $i++) {
            $txt.= $infAdFisco[$i];
            if ($this->GetStringWidth($txt) >= 74 || $i >= strlen($infAdFisco)) {
                $this->setXY(123, 265+$this->extra+($l*3));
                $this->Cell(77, 0, $txt, 0, 0, 'L');
                $txt = '';
                $l++;
            }
        }
	}

}

?>
